"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.connect = exports.DataType = exports.DataFormat = exports.SSLMode = void 0;
const client_js_1 = require("./client.js");
var client_js_2 = require("./client.js");
Object.defineProperty(exports, "SSLMode", { enumerable: true, get: function () { return client_js_2.SSLMode; } });
var types_js_1 = require("./types.js");
Object.defineProperty(exports, "DataFormat", { enumerable: true, get: function () { return types_js_1.DataFormat; } });
Object.defineProperty(exports, "DataType", { enumerable: true, get: function () { return types_js_1.DataType; } });
/** Connect to the database.
 *
 * @remarks
 * You must close the connection after use using {@link Client.end} to close
 * open handles.
 *
 * @returns A database client, with an active connection.
 */
async function connect(config = {}) {
    const client = new client_js_1.ClientImpl(config);
    const info = await client.connect();
    return Object.assign(client, info);
}
exports.connect = connect;
//# sourceMappingURL=index.js.map