"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.warn = exports.log = exports.info = exports.error = exports.debug = void 0;
/* eslint-disable  @typescript-eslint/no-explicit-any */
function make(f) {
    let last = null;
    let count = 0;
    const log = (data) => {
        return f(`ts-postgres: ${data}`);
    };
    return (data) => {
        if (data === last) {
            count++;
        }
        else {
            if (count && last) {
                log(`${last} (repeated ${count} times)`);
                count = 0;
            }
            last = data;
            log(data);
        }
    };
}
exports.debug = make(console.debug);
exports.error = make(console.error);
exports.info = make(console.info);
exports.log = make(console.log);
exports.warn = make(console.warn);
//# sourceMappingURL=logging.js.map